<?php

/**
 * Implements hook_views_data_alter().
 */
function field_columns_views_data_alter(&$data) {
  $state = variable_get('field_columns_state', array());

  foreach ($state as $field_name => $columns) {
    if (isset($data['field_data_' . $field_name])) {
      $field_data = &$data['field_data_' . $field_name];

      foreach ($columns as $column_name => $column) {
        $title = $field_data[$field_name]['title'] . ': ' . $column_name;
        $title_short = $field_data[$field_name]['title short'] . ': ' . $column_name;

        // Apparently some Fields don't have a delta!? Looks like image fields. Let's
        // try one of those too.

        // @todo Single value fields don't have a delta, bc views/modules/field.views.inc
        // doesn't create it, on purpose. Use a better base!

        $base = @$field_data['delta'] ?: @$field_data[$field_name . '_fid'];
        if (!$base) {
          break;
        }

        $field_data[$field_name . '_' . $column_name] = array(
          'title' => $title,
          'title short' => $title_short,
          'help' => drupal_ucfirst($column_name) . ' - ' . $field_data[$field_name]['help'],
        ) + $base;
        $column_data = &$field_data[$field_name . '_' . $column_name];

        $column_data['argument']['field'] =
          $column_data['filter']['field'] =
          $column_data['sort']['field'] = $column_name;

        // If it's not a number, it's a string.
        if (!in_array($column['type'], array('int', 'float'))) {
          $column_data['field']['handler'] = 'views_handler_field';
          $column_data['argument']['handler'] = 'views_handler_argument_string';
          $column_data['filter']['handler'] = 'views_handler_filter_string';
        }

        // Let the module defining these custom fields customize the Views integration.
        $context = compact('field_name', 'column');
        drupal_alter('field_columns_views_data', $column_data, $context);
      }
    }
  }
}
